SystemOrganization addCategory: #'A-Uca-Mascota'!

TestCase subclass: #MascotaVirtualTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A-Uca-Mascota'!

!MascotaVirtualTest methodsFor: 'as yet unclassified' stamp: 'Guidito 9/4/2012 21:52'!
test01dadoUnaMascotaVirtualSuNivelDeContentaDeberiaSerMayorACero
	| unaMascotaVirtual |
	unaMascotaVirtual := MascotaVirtual new.
	self assert: (unaMascotaVirtual nivelContenta >= 0).! !

!MascotaVirtualTest methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 16:13'!
test02DadoUnaMascotaHambrientaSiComeDeberiaPonerseContenta

	| unaMascotaVirtualHambrienta|
	unaMascotaVirtualHambrienta := MascotaVirtual new.
	unaMascotaVirtualHambrienta come.
	self assert:(unaMascotaVirtualHambrienta estaContenta).! !

!MascotaVirtualTest methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:06'!
test03DadoUnaMascotaContentaYComeSuNivelDeContentaDeberiaIncrementarseEnUnidad
      | unaMascotaContenta valorAnterior |
      unaMascotaContenta := MascotaVirtual new.
	valorAnterior := unaMascotaContenta nivelContenta.
	unaMascotaContenta come.
	unaMascotaContenta come.
	self assert:(unaMascotaContenta nivelContenta=(valorAnterior+1)).! !

!MascotaVirtualTest methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:24'!
test04mascotaAburridaComeYhaceMasDe80minEstaAburridaSePoneContenta
     | unaMascotaAburrida temp |
      unaMascotaAburrida := MascotaVirtual new.
	unaMascotaAburrida aburrite:Mas80.
	unaMascotaAburrida come.
	self assert: (unaMascotaAburrida estaContenta).! !

!MascotaVirtualTest methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:24'!
test05mascotaAburridaComeYhaceMenosDe80minEstaAburridaNoPasaNada
     | unaMascotaAburrida |
      unaMascotaAburrida := MascotaVirtual new.
	unaMascotaAburrida aburrite:Menos80.
	unaMascotaAburrida come.
	self assert: (unaMascotaAburrida estaAburrida).! !

!MascotaVirtualTest methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:07'!
test06dadaUnaMascotaQueJuegaSiEstaContentaSuNivelIncrementa2Unidades
	| unaMascotaJuega temp|
      unaMascotaJuega := MascotaVirtual new.
	temp := unaMascotaJuega nivelContenta.
	unaMascotaJuega come.
	unaMascotaJuega juga.
	self assert: (unaMascotaJuega estaContenta).
	self assert: (unaMascotaJuega nivelContenta = (temp+2)).! !

!MascotaVirtualTest methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:30'!
test07dadaUnaMascotaQueJuegaSiEstaAburridaSePoneContenta
	| unaMascotaJuega|
      unaMascotaJuega := MascotaVirtual new.
	unaMascotaJuega aburrite:Mas80.
	unaMascotaJuega juga.
	self assert: (unaMascotaJuega estaContenta).! !

!MascotaVirtualTest methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:33'!
test08dadaUnaMascotaQueJuegaSiEstaHambrientaNoPasaNada
	|unaMascotaJuega|
      unaMascotaJuega := MascotaVirtual new.
	unaMascotaJuega juga.
	self assert: (unaMascotaJuega estaHambrienta).! !

Object subclass: #Estado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A-Uca-Mascota'!

!Estado class methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 12:47'!
dameTuEstado
	^estado.! !

Estado subclass: #EstadoAburrida
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A-Uca-Mascota'!

!EstadoAburrida methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:29'!
come:unaMascota
	(unaMascota tiempoAburrida <= 80) ifFalse:[unaMascota setEstado: EstadoContenta].! !

!EstadoAburrida methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 13:08'!
estaAburrida 
	^true.! !

!EstadoAburrida methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:31'!
juga:unaMascota
	unaMascota setEstado: EstadoContenta.! !

Estado subclass: #EstadoContenta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A-Uca-Mascota'!

!EstadoContenta methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 17:52'!
come:unaMascota
	unaMascota cambiaNivel: (unaMascota nivelContenta)+1.! !

!EstadoContenta methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 13:08'!
estaContenta 
	^true.! !

!EstadoContenta methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:07'!
juga:unaMascota
	unaMascota cambiaNivel: (unaMascota nivelContenta)+2.! !

Estado subclass: #EstadoHambrienta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A-Uca-Mascota'!

!EstadoHambrienta methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 16:17'!
come:unaMascota
	unaMascota setEstado:EstadoContenta.! !

!EstadoHambrienta methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 13:08'!
estaHambrienta
	^true.! !

!EstadoHambrienta methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:34'!
juga:unaMascota
	^'No puede jugar'! !

Object subclass: #MascotaVirtual
	instanceVariableNames: 'nivelContenta unTimer unEstado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A-Uca-Mascota'!

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:24'!
aburrite:unTiempo
	self setEstado: EstadoAburrida.
	self setTimer: unTiempo.! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 17:51'!
cambiaNivel:unValor
	 nivelContenta:= self nivelContenta + unValor.! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 16:38'!
come
	unEstado come:self.! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 14:16'!
estaAburrida 
    ^unEstado estaAburrida.
! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 14:16'!
estaContenta 
    ^unEstado estaContenta .
! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 14:15'!
estaHambrienta  
    ^unEstado estaHambrienta.
! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 17:42'!
initialize
	nivelContenta := 0.
	unEstado:=EstadoHambrienta new.
	unTimer:=Mas80 new.! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 18:08'!
juga
	unEstado juga:self.! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 13:19'!
nivelContenta
	 ^nivelContenta.! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 16:12'!
setEstado:estado
	unEstado:= estado new.! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 16:15'!
setTimer:unTiempo
	unTimer:= unTiempo new.! !

!MascotaVirtual methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 15:51'!
tiempoAburrida
	^unTimer dameTiempo.! !

Object subclass: #Timer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A-Uca-Mascota'!

Timer subclass: #Mas80
	instanceVariableNames: 'tiempoAburrida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A-Uca-Mascota'!

Mas80 class
	instanceVariableNames: 'tiempo'!

Mas80 class
	instanceVariableNames: 'tiempo'!

!Mas80 methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 15:51'!
dameTiempo 
	^tiempoAburrida! !

!Mas80 methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 14:13'!
initialize 
	tiempoAburrida:=81.! !

Timer subclass: #Menos80
	instanceVariableNames: 'tiempoAburrida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A-Uca-Mascota'!

!Menos80 methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 15:52'!
dameTiempo
	^tiempoAburrida.! !

!Menos80 methodsFor: 'as yet unclassified' stamp: 'Guidito 9/10/2012 14:13'!
initialize 
	tiempoAburrida:=79.! !
